{-# OPTIONS_GHC -Wno-orphans #-}
{-# LANGUAGE TypeApplications #-}
{-# LANGUAGE MultiWayIf #-}

module Gargantext.Orphans.Accelerate () where

import Prelude
import Test.QuickCheck
import Data.Array.Accelerate hiding ((<=))
import qualified Data.Array.Accelerate.Sugar.Shape as A

instance Arbitrary DIM0 where
  arbitrary = return Z

instance Arbitrary DIM1 where
  arbitrary = (Z :.) <$> choose (0,1024)
  shrink = \(Z :. i) -> if i <= 0 then [] else [Z :. i - 1 ]

instance Arbitrary DIM2 where
  arbitrary = do
    x <- choose (0,128)
    y <- choose (0,48)
    return (Z :. y :. x)
  shrink = \(Z :. r :. c) ->
    if | r <= 0 -> []
       | c <= 0 -> []
       | otherwise -> [Z :. (r - 1)
                         :. (c - 1)
                      ]

instance Arbitrary DIM3 where
  arbitrary = do
    x <- choose (0,64)
    y <- choose (0,32)
    z <- choose (0,16)
    return (Z :. z :. y :. x)

instance (Arbitrary sh, Shape sh, Elt e, Arbitrary e) => Arbitrary (Array sh e) where
  arbitrary = do
    sh <- arbitrary
    fromList sh <$> vectorOf (A.size sh) arbitrary

